      implicit none
      character LINE1*20
      real*8 Kc,n,rhobar,rhoc,M,R
      real*8 fac1,g,power,pi,rconrbar
      real*8 fac(30),rho(30)

      real*4 mass(30),radius(30)
      real*8 mass1(30),radius1(30)

      integer i,j,cindex,k,l,iwrite

      Kc=1.d14
      G=6.67e-8
      pi=3.14159
      cindex=1
      iwrite=0


      do i=1,30
         fac(i)=0.0
         rho(i)=0.0
         mass(i)=0.0
         radius(i)=0.0
         mass1(i)=0.0
         radius1(i)=0.0
      enddo

      fac(20)=2.41105
      fac(21)=2.36093
      fac(22)=2.31368
      fac(23)=2.26910
      fac(24)=2.22700
      fac(25)=2.18720
      fac(26)=2.14957
      fac(27)=2.11397
      fac(28)=2.08028
      fac(29)=2.04840

      rho(20)=11.40254
      rho(21)=13.06668
      rho(22)=15.03496
      rho(23)=17.35477
      rho(24)=20.11152
      rho(25)=23.40646
      rho(26)=27.36972
      rho(27)=32.17031
      rho(28)=38.02825
      rho(29)=45.23552


      do i=20,27
         n=float(i)*0.1
         fac1=fac(i)
         rconrbar=rho(i)


         do j=6,14
            m=float(j)*0.1

      power=(1/n -1)*1.5 + 1

      rhoc=M*2.e33*((4.*pi*G)**1.5)
      rhoc=rhoc/4/pi/fac1/(Kc**1.5)
      rhoc=rhoc/((n+1)**1.5)
      rhoc=rhoc**(1/power)
      rhobar = rhoc/rconrbar

      R=(3.*M*2.e33)/(4.*3.14159*rhobar)
      R=R**0.333333333

         R=R/6.38e8

         if(iwrite.eq.0) then
            iwrite=1
            write(6,101)
         endif
 101     format('  n   M/MSun    rho_c   R/REarth')
         write(6,100) n,m, rhoc,R
 100     format(1x,f3.1,2x,f4.2,2x,1pe10.3,2x,0pf7.4)

         mass1(j)=M
         radius1(j)=R

         enddo

         write(6,*) ' '
         if(i.eq.20) then
           CALL PGBEG(0,'?',1,1)
           call pgpap(10.0,0.8)
           call pgenv(0.55,1.45,0.0,23.0,0,0)
           call pglabel('M/MSun', 'R/REarth',
     &                ' White Dwarfs')
         endif

         do k=6,14
            l=k-5
            mass(l)=mass1(k)
            radius(l)=radius1(k)
         enddo
         cindex=cindex+1
         call pgsci(cindex)
         call pgline(9,mass,radius)
         call pgpoint(9,mass,radius,254)
         write(LINE1,500) n
500      format('n=',f3.1)
         if(i.eq.20) then
            call pgmtxt('T',-3.0,0.15,0.5,LINE1)
         else if(i.eq.21) then
            call pgmtxt('T',-10.0,0.15,0.5,LINE1)
         else if(i.eq.22) then
            call pgmtxt('T',-18.0,0.15,0.5,LINE1)
         else if(i.eq.23) then
            call pgmtxt('T',-23.0,0.15,0.5,LINE1)
         else if(i.eq.24) then
            call pgmtxt('T',-27.0,0.15,0.5,LINE1)
         else if(i.eq.25) then
            call pgmtxt('T',-30.0,0.15,0.5,LINE1)
         else if(i.eq.26) then
            call pgmtxt('T',-31.4,0.1,0.5,LINE1)
         else if(i.eq.27) then
            call pgmtxt('T',-33.0,0.2,0.5,LINE1)
         endif

C         write(6,*) (mass(k),radius(k),k=1,5)

      enddo


      call pgend

      stop
      end
