      implicit none
      character LINE1*40
      real*4 temp,xmin,xmax,ymin,ymax
      real*4 t(100),pp(100),cno(100)
      integer i,j

      do i=1,30
         temp=float(i)
         t(i)=temp
         pp(i)=log10(2.4e6*(temp**(0.667))*exp(-33.8/(temp**0.33333)))
         cno(i)=log10(
     &           8.6e27*(temp**(0.667))*exp(-152.3/(temp**0.33333)))
      enddo

      xmin=t(1)
      xmax=t(30)
      ymin=100
      ymax=-100
      do i=1,100
         ymin=min(ymin,pp(i))
         ymin=min(ymin,cno(i))
         ymax=max(ymax,pp(i))
         ymax=max(ymax,cno(i))
      enddo
      if(ymin.lt.1.e-10) ymin=-5
      CALL PGBEG(0,'?',1,1)
      call pgpap(10.0,0.8)

C      write(6,*) xmin,xmax,ymin,ymax

      call pgenv(xmin,xmax,ymin,ymax,0,0)
      call pglabel('T/million K', 'Log Rate',
     &                'pp and CNO burning rates')


         write(LINE1,510)
         call pgsci(2)
         call pgmtxt('T',-15.0,0.8,0.5,LINE1)
 510     format('pp')

         write(LINE1,520)
         call pgsci(3)
         call pgmtxt('T',-4.0,0.77,0.5,LINE1)
 520     format('CNO')

         call pgsci(2)
         call pgline(30,t,pp)
         call pgsci(3)
         call pgline(30,t,cno)
         call pgend
         stop
         end
